// Pendulo amortecido e forcado 
// Solucao pelo metodo de Runge-Kutta 4a ordem
// Entre com tmax e v0 como parametros do programa

#include<stdio.h>
#include<stdlib.h>
#include<math.h>

#define D_PI (3.141592653589793239L)
#define FW(theta) (-gl*sin(theta))
#define FQ(omega) (omega)

int main(int argv, char **argc){
  
  double g,l,q,qa,w,wa,t,tmax,dt,v0,k1,k2,k3,k4,l1,l2,l3,l4,gl,c6;
  unsigned long int it,idt;
  FILE *out_ptr;
  char arq[100];

  if(argv != 2){
    printf("Uso: %s <tmax>\n",argc[0]);
    exit(1);
  }

  //  dt=1.0L/(double)(1UL<<15);
  dt=0.00001;
  l=2.0;
  g=9.81;
  gl=g/l;
  c6=1.0/6.0;

  tmax=atof(argc[1]);
  v0=8.85889;
  wa=v0/l;  
  qa=0.0;
  printf("V0=%lf w0=%lf\n",v0,wa);

  sprintf(arq,"evol_c.data");
  out_ptr=fopen(arq,"w");
  
  it=0;
  idt=(unsigned long)(0.1/dt);

  for(t=dt;t<tmax;t+=dt){

    k1=dt*FW(qa);
    l1=dt*FQ(wa);
    k2=dt*FW(qa+l1/2.0);
    l2=dt*FQ(wa+k1/2.0);
    k3=dt*FW(qa+l2/2.0);
    l3=dt*FQ(wa+k2/2.0);
    k4=dt*FW(qa+l3);
    l4=dt*FQ(wa+k3);

    w=wa+c6*(k1+2.0*k2+2.0*k3+k4);
    q=qa+c6*(l1+2.0*l2+2.0*l3+l4);

    //fmod(double a,double b) :: resto da divisao de a por b
    if(it==idt){
      printf("%lf %lf %lf\n",t,w,fmod(q,2.0*D_PI));
      fprintf(out_ptr,"%lf %lf %lf %lf\n",t,w,fmod(q,2.0*D_PI),(v0/sqrt(g*l))*sin(sqrt(gl)*t));
      it=0;
    }
    wa=w;
    qa=q;
    it++;
  }
  fclose(out_ptr);
  
  return(0);
}

