c     Pendulo amortecido e forcado 
c     Solucao pelo metodo de Runge-Kutta 4a ordem
c     Entre com tmax e v0 como parametros do programa

      program pendulum
      
      double precision  g,R,q,qa,w,wa,t,tmax,dt,v0,k(4),l(4),gR,c6
      double precision FW,FQ
      integer it,idt
      parameter (D_PI=3.141592653589793239D0)
      
      dt=2.0**(-15)
c      dt=0.00001D0
      R=2.0D0
      g=9.81D0
      gR=g/R
      c6=1.0D0/6.0D0
      
      tmax=20.0D0
      v0=8.85889D0
      wa=v0/R
      qa=0.0D0
      
      open(UNIT=10,FILE='evol_f.data',STATUS='UNKNOWN')
      
      it=0
      idt=int(0.1D0/dt)
      t=dt
      do while(t.LT.tmax)
         
         k(1)=dt*FW(gR,qa)
         l(1)=dt*FQ(wa)
         k(2)=dt*FW(gR,qa+l(1)/2.0)
         l(2)=dt*FQ(wa+k(1)/2.0)
         k(3)=dt*FW(gR,qa+l(2)/2.0)
         l(3)=dt*FQ(wa+k(2)/2.0)
         k(4)=dt*FW(gR,qa+l(3))
         l(4)=dt*FQ(wa+k(3))
         
         w=wa+c6*(k(1)+2.0*k(2)+2.0*k(3)+k(4))
         q=qa+c6*(l(1)+2.0*l(2)+2.0*l(3)+l(4))
         
         if(it.EQ.idt) then
            write(*,*) t,w,mod(q,2.0*D_PI)
            write(10,*) t,w,q
c            write(10,*) t,w,mod(q,2.0*D_PI)
            it=0
         endif
         
         wa=w
         qa=q
         t=t+dt
         it=it+1
      enddo
 110  format (4(F3.6))
      close(10)
      
      return
      end
      
      double precision function FW(gR,theta)
      double precision gR,theta
      FW=(-gR*sin(theta))
      return 
      end

      double precision function FQ(omega)
      double precision omega
      FQ=omega
      return
      end
